/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Download Statusbar.
 *
 * The Initial Developer of the Original Code is
 * Devon Jensen.
 *
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Devon Jensen <velcrospud@hotmail.com>
 *
 * Parts of some functions are based on similar functions in downloadpanel.js 
 * and nsProgressDialog.js found in Phoenix/Firebird build Jan.26, 2003.
 * Contributors to those projects are respectively: <unknown> and <Bill Law
 * and Aaron Kaluszka>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


var db_gDownloadManager;
var db_currentelem;
var db_requests = new Array( );
var db_paused = new Array( );
var db_displayprefs = new Array ( );
window.addEventListener("focus", downbarinit, false);
var lastID = "nothing";
var db_datasource;
	
//var aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);

function downbarinit() {
	
  	window.removeEventListener("focus", downbarinit, false);
	
	var downbarelem = document.getElementById("downbar");
	
	const db_dlmgrContractID = "@mozilla.org/download-manager;1";
	const db_dlmgrIID = Components.interfaces.nsIDownloadManager;
	db_gDownloadManager = Components.classes[db_dlmgrContractID].getService(db_dlmgrIID);
	
	const rdfSvcContractID = "@mozilla.org/rdf/rdf-service;1";
	const rdfSvcIID = Components.interfaces.nsIRDFService;
	gRDFService = Components.classes[rdfSvcContractID].getService(rdfSvcIID);
	
	var gIOService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var profile = Components.classes["@mozilla.org/profile/manager;1"].getService(Components.interfaces.nsIProfileInternal);
	var gProfileDirURL = gIOService.newFileURI(profile.getProfileDir(profile.currentProfile));
	//aConsoleService.logStringMessage("file://" + gProfileDirURL.path + "downloads.rdf");
	
	db_datasource = gRDFService.GetDataSource("file://" + gProfileDirURL.path + "downloads.rdf");
		
	downbarelem.database.AddDataSource(db_datasource);
	downbarelem.builder.rebuild();
	
	//var db_observerService = Components.classes["@mozilla.org/observer-service;1"]
	 //                                 .getService(Components.interfaces.nsIObserverService);
	//db_observerService.addObserver(db_dlObserver, "dl-progress", false);
	//db_observerService.addObserver(db_dlObserver, "dl-done", false);
	//db_observerService.addObserver(db_dlObserver, "dl-cancel", false);
	//db_observerService.addObserver(db_dlObserver, "dl-failed", false);
	//db_observerService.addObserver(db_dlObserver, "download-starting", false);

	readPrefs();
	setAllDisplayItems();
	// checkHeight();
	checkChildren();

	//toJavaScriptConsole();
	window.setInterval("checkChildren()", 1000);
}

function downbarclose() {
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var clearnow = pref.getBoolPref("downbar.function.clearOnClose");
	if (clearnow) removeit(null, true);
	
	//var db_observerService = Components.classes["@mozilla.org/observer-service;1"]
	 //                                 .getService(Components.interfaces.nsIObserverService);
	//db_observerService.removeObserver(db_dlObserver, "dl-progress");
	//db_observerService.removeObserver(db_dlObserver, "dl-done");
	//db_observerService.removeObserver(db_dlObserver, "dl-cancel");
	//db_observerService.removeObserver(db_dlObserver, "dl-failed");
	//db_observerService.removeObserver(db_dlObserver, "download-starting");
}

/*const db_dlObserver = {
  observe: function(subject, topic, state) {
  	
  	//aConsoleService.logStringMessage(subject);
	
	var db_dl = subject.QueryInterface(Components.interfaces.nsIDownload);
  	
	if (topic == "download-starting") {
		db_dl.listener = dbListener;
		//window.setTimeout("checkHeight()", 100);
	}
	
	if (topic == "dl-done") {  // Can't use in mozilla
		// add a small animation or blink with PREF
		var elmpath = db_dl.target.path;
		
		//check if it's an image, if so, remove download after xx sec
		var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		try {
			var autoDremove = pref.getBoolPref("downbar.download.autoRemove");
			var Daftersec = pref.getIntPref("downbar.download.timeToClear");
			var autoIremove = pref.getBoolPref("downbar.image.autoRemove");
			var Iaftersec = pref.getIntPref("downbar.image.timeToClear");
		}
		catch (e) {}
		
		// check if it's an image, if image autoclear, set timeout to remove it
		var db_fileext = elmpath.split(".").pop().toLowerCase();
		if (db_fileext == "jpg" | db_fileext == "gif" | db_fileext == "jpeg" | db_fileext == "png" | db_fileext == "bmp") {
			if (autoIremove) {
				var fixedelmpath = elmpath.replace(/\\/g, "\\\\");  // The \ and ' get messed up in the command if they are not fixed
				fixedelmpath = fixedelmpath.replace(/\'/g, "\\\'");
				window.setTimeout("removeit('" + fixedelmpath + "'," + false + ")", Iaftersec*1000);
			}
		}
    	
    	// all other downloads autoclear
    	else if (autoDremove) {
	    		var fixedelmpath = elmpath.replace(/\\/g, "\\\\");
	    		fixedelmpath = fixedelmpath.replace(/\'/g, "\\\'");
				window.setTimeout("removeit('" + fixedelmpath + "'," + false + ")", Daftersec*1000);
		}
    	
    }
  }
}*/

const dbListener = {
		onStateChange : function(aWebProgress, aRequest, aStateFlags, aStatus) {
			
			// I wanted to use this for after download functions but it doesn't send a Request. BUG? (with the URL to identify which element completed!)
			
			/* // Download is finished - check prefs to get rid of it - moved here for mozilla compatibility - instead of using firebird only "dl-done"
			if (aStateFlags == 16) {  // The state flag for STATE_STOP is hex 0x10 - see nsiwebprogresslistener.idl for others
				aConsoleService.logStringMessage("gotin");
				// Get a reference to the element in question
				var dbelems = document.getElementById("downbar").childNodes;
				var doneElem;
				var i = 1;
				aConsoleService.logStringMessage(aRequest);
				while (i < dbelems.length) {
					aConsoleService.logStringMessage(i);
					if (dbelems[i].getAttribute("pURL") == aRequest.name) {
						doneElem = dbelems[i];
						aConsoleService.logStringMessage("setit");
					}
					i = i + 1;
				}

				for (i = 1; i <= dbelems.length - 1; ++i) {
					aConsoleService.logStringMessage(dbelems[i].getAttribute("pURL"));
					if (dbelems[i].getAttribute("pURL") == aRequest.name) {
						doneElem = dbelems[i];
					}
				}
				if (!doneElem) {return;}
		  	}*/
		
		},
		
		onProgressChange : function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress){

			// Store a reference to its request, find out which element this is for
			var dbelems = document.getElementById("downbar").childNodes;
			var progElem;
			var index;
			var isPaused;
			if (!aRequest) {return;}
			
			for (i = 1; i <= dbelems.length - 1; ++i) {
				if (dbelems[i].getAttribute("pURL") == aRequest.name) {
					// Add if statement - if (!db_requests[i]) then set the request 
					db_requests[i] = aRequest;
					progElem = dbelems[i];
					index = i;
					isPaused = db_paused[i];
				}
			}
			if (!progElem) {return;}
						
			var now = ( new Date() ).getTime();
			
			// If the element has the default value for speed, it is new, set all displays
			if (progElem.lastChild.lastChild.firstChild.nextSibling.value == "1") {
				setAllDisplayItems();
				// checkHeight();
			}
			
			// If we don't have any info saved yet, save the current info and return
			if (!progElem.pSavedBytes | !progElem.pLastUpdate) {
				progElem.pSavedBytes = aCurTotalProgress;
				progElem.pLastUpdate = now;
				return;
			}
			
			// Don't want to update the speed if it is paused
			if (isPaused) {return;}
			
			// For mozilla, since it doesn't have dl-done - this won't work for cached images that are saved = no image autoremoval
			if (aCurTotalProgress == aMaxTotalProgress) {
					var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
					try {
						var autoDremove = pref.getBoolPref("downbar.download.autoRemove");
						var Daftersec = pref.getIntPref("downbar.download.timeToClear");
					}
					catch (e) {}
					if (autoDremove) {
			    		var fixedelmpath = progElem.id.replace(/\\/g, "\\\\");
			    		fixedelmpath = fixedelmpath.replace(/\'/g, "\\\'");
						window.setTimeout("removeit('" + fixedelmpath + "'," + false + ")", Daftersec*1000);
					}
					
			}
			
			// If the rate hasn't been set yet we'll use this interval or wait for xx sec interval ADD PREF?
			if (now - progElem.pLastUpdate > 1000) {
				
				// the the mode is undetermined, just count up the MB
				if (aMaxTotalProgress == "-1" | parseInt(aCurTotalProgress) > parseInt(aMaxTotalProgress) ) {
					
					progElem.lastChild.lastChild.firstChild.hidden = true;
					progElem.lastChild.lastChild.firstChild.nextSibling.hidden = true;
					progElem.lastChild.lastChild.lastChild.hidden = true;
					progElem.lastChild.lastChild.lastChild.previousSibling.hidden = false;
					
					someBytes = aCurTotalProgress / 1024 / 1024;
					var mBfrac = parseInt( ( someBytes - ( someBytes = parseInt( someBytes ) ) ) * 10);
					progElem.lastChild.lastChild.lastChild.previousSibling.value = "Unk. " + someBytes + "." + mBfrac + " MB";
					progElem.pSavedBytes = aCurTotalProgress;
					progElem.pLastUpdate = now;
					return;
				}
				
				// Calculate percent 
					//- do it here because of a bug in dlmanager that makes negitive percentages with large files
				var currpercent = parseInt(aCurTotalProgress * 100 / aMaxTotalProgress);
				progElem.firstChild.setAttribute("value", currpercent);
				progElem.lastChild.lastChild.firstChild.setAttribute("value", (currpercent + "%"));
				
				// Calculate speed
				var oldrate = parseInt(progElem.lastChild.lastChild.firstChild.nextSibling.value);
				var elapsed = now - progElem.pLastUpdate;
				var rate = ((aCurTotalProgress - progElem.pSavedBytes)* 1000 ) / elapsed;
				var kRate = parseInt(rate / 1024); // KBytes/sec
				
				// Use average of the last two intervals so the speed doesn't jump around as much
				var avgrate = (kRate + oldrate) / 2;
	        	var fraction = parseInt( ( avgrate - ( avgrate = parseInt( avgrate ) ) ) * 10);
	        	var newrate = avgrate + "." + fraction;
	        	//aConsoleService.logStringMessage(oldrate + " + " + kRate + " /2 = " + newrate);
				progElem.lastChild.lastChild.firstChild.nextSibling.value = newrate;
				
				// Fix and set the size downloaded so far
				if (db_displayprefs[2]) {
					var currkb = parseInt(aCurTotalProgress / 1024); // KBytes
					progElem.lastChild.lastChild.lastChild.previousSibling.value = currkb + " KB";
				}
				
				// Calculate and set the remaining time
				if (db_displayprefs[3]) {
					var remainingkb = parseInt((aMaxTotalProgress - aCurTotalProgress) / 1024);
					var secsleft = (1 / newrate) * remainingkb;
					var remaintime = formatSeconds(secsleft);
					progElem.lastChild.lastChild.lastChild.value = remaintime;
				}
				// Got our info, now grab new values
				progElem.pSavedBytes = aCurTotalProgress;
				progElem.pLastUpdate = now;
				progElem.pTotalBytes = aMaxTotalProgress;

			}
			
		},
		
		onLocationChange : function(aWebProgress, aRequest, aLocation) {
		},
		
		onStatusChange : function(aWebProgress, aRequest, aStatus, aMessage) {
		},
		
		onSecurityChange : function(aWebProgress, aRequest, aState) {
		//aConsoleService.logStringMessage("sec change");
		}
}

function Commandswitcher(aCommand)  {

    switch (aCommand) {
    case "cmd_db_openfinished":
      openfinished(db_currentelem);
      break;
    case "cmd_db_showfile":
      showfile(db_currentelem);
      break;
    case "cmd_db_paures":
      pauseresumeTog(document.getElementById(db_currentelem), null);
      break;  
    /*case "cmd_db_viewprop":
      viewprop(db_currentelem);
      break;*/
    case "cmd_db_remove":
      removeit(db_currentelem, false);
      break;
	case "cmd_db_cancel":
      cancelprogress(db_currentelem);
      break;
    case "cmd_db_copyURL":
      copyURL(db_currentelem);
      break;    
    /*case "cmd_db_expand":
      expandtowindow(db_currentelem);
      break; */ 
    /*case "cmd_db_restart":
      restart(db_currentelem);
      break;*/
    default:
    }
}  

function openfinished(elemtoopen) {
	var file = createLocalFile(elemtoopen);
    file.launch();
    removeit(elemtoopen);
}

function showfile(idtoshow) {
	var file = createLocalFile(idtoshow);
    file.reveal();
    removeit(idtoshow);
}

function pauseresumeTog(elem, aEvent) {
	try {
		if (aEvent.button == 2)	return;
	}
	catch (e) {}
		
	var dbelems = document.getElementById("downbar").childNodes;
	var request;
	var index;
	for (i = 1; i <= dbelems.length - 1; ++i) {
		if (dbelems[i] == elem) {
			request = db_requests[i];
			index = i;
			//aConsoleService.logStringMessage(request.name + " " + i);
		}
	}
	if (!request) {return;}
	
	if (db_paused[index]) {
		request.resume();
		db_paused[index] = false;
		elem.pPaused = false;
		elem.setAttribute("style", "border: 1px solid threeDShadow;");
		// remove the paused indication on tooltip
	}
	else {
		request.suspend();
		db_paused[index] = true;
		elem.pPaused = true;
		elem.setAttribute("style", "border: 1px solid red;");
		elem.lastChild.lastChild.firstChild.nextSibling.value = "0"
		// add a visual paused indication to tooltip
	}
}

/*function viewprop(idtoview) {
	window.openDialog("chrome://browser/content/downloads/downloadProperties.xul",
                        "_blank", "modal,centerscreen,chrome,resizable=no", idtoview);
}*/

function removeit(idtoremove, allofthem){
	var downbarelem = document.getElementById("downbar");
	var dbelems = document.getElementById("downbar").childNodes;
	
    // fix the request array
    if (allofthem) {
		for (i = 1; i <= dbelems.length - 1; ++i) {
			if (dbelems[i].getAttribute("context") == "donecontext") {
				db_requests.splice(i,1);
				db_paused.splice(i,1);
				//aConsoleService.logStringMessage("fixed " + i);
			}
		}
	}
    else {
    	for (i = 1; i <= dbelems.length - 1; ++i) {
			if (dbelems[i].id == idtoremove) {
				db_requests.splice(i,1);
				db_paused.splice(i,1);
			}
		}
    }
    
	// Now to the removal business
	var observer = downbarelem.builder.QueryInterface(Components.interfaces.nsIRDFObserver);
    var ds = downbarelem.database;
    observer.beginUpdateBatch(ds);
	db_gDownloadManager.startBatchUpdate();
	
	if (allofthem) {
		var comparray = downbarelem.getElementsByAttribute("context", "donecontext");
		for (i = 1; i <= comparray.length - 1; ++i) {
        	db_gDownloadManager.removeDownload(comparray[i].id);
        	//downbarelem.removeChild(document.getElementById(comparray[i].id)); hmm, this doesn't work right have to rebuild instead
        }
	}
	else {
		db_gDownloadManager.removeDownload(idtoremove);
		//downbarelem.removeChild(document.getElementById(idtoremove));
	}
	
	observer.endUpdateBatch(ds);
	var remote = db_datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
    remote.Flush();
    db_gDownloadManager.endBatchUpdate();
    downbarelem.builder.rebuild();  // Would prefer to use removechild above but it doesn't work quite right when you download a file you already removed
    
    // Since the downbar was rebuilt, need to set the diplay again
    setAllDisplayItems();
    // checkHeight();
}

function cancelprogress(elemtocancel) {
	var dbelems = document.getElementById("downbar").childNodes;
	for (i = 1; i <= dbelems.length - 1; ++i) {
		if (dbelems[i].id == elemtocancel) {
			db_requests.splice(i,1);
			db_paused.splice(i,1);
		}
	}
	db_gDownloadManager.cancelDownload(elemtocancel);
	// checkHeight();
	// Downloads are left in state 3 when canceled, I could remove them completely, but they could be used for resume across session
	//removeit(elemtocancel, false);
}

function cancelall() {
	var dbelems = document.getElementById("downbar").childNodes;
	for (i = 1; i <= dbelems.length - 1; ++i) {
			if (dbelems[i].getAttribute("context") == "progresscontext") {
				db_requests.splice(i,1);
				db_paused.splice(i,1);
				db_gDownloadManager.cancelDownload(dbelems[i].id);
			}
	}
	// checkHeight();
}

function copyURL (elemtocopy) {
	
	const gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"]
														.getService(Components.interfaces.nsIClipboardHelper);
	gClipboardHelper.copyString(document.getElementById(elemtocopy).getAttribute("pURL"));
}

function updatecurrent(newelemid) {
	db_currentelem = newelemid;
}

function createLocalFile(aFilePath)
{
  var lfContractID = "@mozilla.org/file/local;1";
  var lfIID = Components.interfaces.nsILocalFile;
  var lf = Components.classes[lfContractID].createInstance(lfIID);
  lf.initWithPath(aFilePath);
  return lf;
}

function labeldecide(elem) {
	if (elem.pPaused) document.getElementById("PauResLabel").label = "Resume";
	else document.getElementById("PauResLabel").label = "Pause";
}

function setAllDisplayItems() {
	var dbelems = document.getElementById("downbar").childNodes;
	var numtrue = db_displayprefs[5];
	
	// Set the paused state and the display items
	for (i = 1; i <= dbelems.length - 1; ++i) {
		if (dbelems[i].getAttribute("context") == "progresscontext") {
			if (db_paused[i]) {
				dbelems[i].setAttribute("style", "border: 1px solid red;");
				dbelems[i].pPaused = true;
			}
			else dbelems[i].setAttribute("style", "border: 1px solid threeDShadow;");
			
			// If there is only one displayed, make is bigger
			if (numtrue < 2) {				
				dbelems[i].lastChild.lastChild.firstChild.setAttribute("style", "font-size: 7pt;");
				dbelems[i].lastChild.lastChild.firstChild.nextSibling.setAttribute("style", "font-size: 7pt;");
				dbelems[i].lastChild.lastChild.lastChild.previousSibling.setAttribute("style", "font-size: 6pt;");
				dbelems[i].lastChild.lastChild.lastChild.setAttribute("style", "font-size: 7pt;");
			}
			
			if (db_displayprefs[0]) dbelems[i].lastChild.lastChild.firstChild.hidden = false;
			if (db_displayprefs[1]) dbelems[i].lastChild.lastChild.firstChild.nextSibling.hidden = false;
			if (db_displayprefs[2]) dbelems[i].lastChild.lastChild.lastChild.previousSibling.hidden = false;
			if (db_displayprefs[3]) dbelems[i].lastChild.lastChild.lastChild.hidden = false;
			
			var percentC = db_gDownloadManager.getDownload(dbelems[i].id).percentComplete;
			dbelems[i].firstChild.setAttribute("value", percentC);
			dbelems[i].lastChild.lastChild.firstChild.setAttribute("value", percentC + "%");
			dbelems[i].lastChild.lastChild.firstChild.nextSibling.value = 0;
		}
	}
}

function repeattooltip() {
	var elem = document.getElementById(db_currentelem);
	elem.pIvalCode = window.setInterval("maketooltip()", 1000);
}

function stoptooltip() {
	var elem = document.getElementById(db_currentelem);
	window.clearInterval(elem.pIvalCode);
}

function maketooltip() {
	var elem = document.getElementById(db_currentelem);
	if (!elem.lastChild.lastChild) {
		stoptooltip();
	}
	else {
		var elem = document.getElementById(db_currentelem);
		var source = elem.getAttribute("pURL");
		var target = elem.id;
		var percent = elem.lastChild.lastChild.firstChild.value;
		var speed = elem.lastChild.lastChild.firstChild.nextSibling.value;
		var currbytes = elem.pSavedBytes;
		var totalbytes = elem.pTotalBytes;
		
		var currkb = parseInt(currbytes / 1024); // KBytes
		var totalkb = parseInt(totalbytes / 1024); // KBytes
		
		var remainingkb = totalkb - currkb;
		var secsleft = (1 / speed) * remainingkb;
		var remaintime = formatSeconds(secsleft);
			
		document.getElementById("source").value = source;
		document.getElementById("target").value = target;
		document.getElementById("status").value = currkb  + " KB of " + totalkb + " KB (at " + speed + " KB/sec)";
		document.getElementById("timeLeft").value = remaintime;
		document.getElementById("percentText").value = percent;
	}
}

function formatSeconds (secs) {
// Round the number of seconds to remove fractions.
	secs = parseInt( secs + .5 );
	var hours = parseInt( secs/3600 );
	secs -= hours*3600;
	var mins = parseInt( secs/60 );
	secs -= mins*60;
	var result;
	
    if ( mins < 10 )
        mins = "0" + mins;
    if ( secs < 10 )
        secs = "0" + secs;
    
    if (hours) {
    	if ( hours < 10 ) hours = "0" + hours;
    	result = hours + ":" + mins + ":" + secs;
	}
	else result = mins + ":" + secs;
    
    return result;
}

function pauseall () {
	var dbelems = document.getElementById("downbar").childNodes;
	var i = 1;
	// I don't know why a for loop won't work here but okay
	while (i < dbelems.length) {
		
		if (dbelems[i].getAttribute("context") == "progresscontext") {
			if (!db_paused[i]) pauseresumeTog(dbelems[i], null);
		}
		i = i + 1;
	}
}

function resumeall () {
	var dbelems = document.getElementById("downbar").childNodes;
	var i = 1;
	while (i < dbelems.length) {
		if (dbelems[i].getAttribute("context") == "progresscontext") {
			if (db_paused[i]) pauseresumeTog(dbelems[i], null);
		}
		i = i + 1;
	}
}

function checkHeight () {
	
	var downbarelem = document.getElementById("downbar");
	if (downbarelem.boxObject.height == 22) {
		downbarelem.setAttribute("style", "border: 1px solid ThreeDShadow;");
	}
	if (downbarelem.boxObject.height == 2) {
		downbarelem.setAttribute("style", "border: 0px solid ThreeDShadow;");
	}
}

function readPrefs () {
	// Get and save display prefs
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	
	try {
		db_displayprefs[0] = pref.getBoolPref("downbar.display.percent");
		db_displayprefs[1] = pref.getBoolPref("downbar.display.speed");
		db_displayprefs[2] = pref.getBoolPref("downbar.display.size");
		db_displayprefs[3] = pref.getBoolPref("downbar.display.time");
	}
	catch (e){}
	
	// Find the number of items displayed (used in setAllDisplayItems)
	var numtrue = 0;
	for (i = 0; i <= 3; ++i) {
		if (db_displayprefs[i]) 
			numtrue = numtrue + 1;
	}
	db_displayprefs[5] = numtrue;
	
}

function checkChildren() {
	var downbarelem = document.getElementById("downbar")
	var dbelems = downbarelem.childNodes;
	
	if (downbarelem.lastChild.id == lastID) {
		var i = 1;
		var db_dl;
		while (i < dbelems.length) {
			if (dbelems[i].getAttribute("context") == "progresscontext") {
				db_dl = db_gDownloadManager.getDownload(dbelems[i].id);
				db_dl.listener = dbListener;
			}
			i = i + 1;
		}
	}
	lastID = downbarelem.lastChild.id;
}

/*function restart (elemid) {  // Future - Experimental resume across session -
	
	var sourcepath = document.getElementById(elemid).getAttribute("sourcepath");
	
	/*var browser = document.getElementById("content");
	browser.loadURI(sourcepath);
	
	 // Or try to start the download myself, better no filepicker
    aURI = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
	aURI.path = sourcepath;
	var lf = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    lf.initWithPath(elemid);
    aConsoleService.logStringMessage(lf.path);
    aConsoleService.logStringMessage(aURI.path);
    
    const persistContractID = "@mozilla.org/embedding/browser/nsWebBrowserPersist;1";
    const persistIID = Components.interfaces.nsIWebBrowserPersist;
    persist = Components.classes[persistContractID].createInstance(persistIID);
    const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
    const flags = nsIWBP.PERSIST_FLAGS_NO_CONVERSION;
    persist.persistFlags = flags | nsIWBP.PERSIST_FLAGS_BYPASS_CACHE;
    //alert("madeit");
	var dl = Components.classes["@mozilla.org/download;1"].createInstance(Components.interfaces.nsIDownload);
	dl.init(tempSource, tempTarget, null, tempMIME, tempStartTime, persist);
	persist.saveURI(tempSource, null, null, null, null, tempTarget);
	
}*/

/* function expandtowindow (elemid) {  // Depreciated - Now showing tooltip instead - could come back in the future
	
	//This will be all that is needed in this function, pending on bug 200760
	//db_gDownloadManager.openProgressDialogFor(elemid, window);
	//Ugly fix for now
	
	var pdialog = Components.classes["@mozilla.org/progressdialog;1"].createInstance(Components.interfaces.nsIProgressDialog);	
	var dl = pdialog.QueryInterface(Components.interfaces.nsIDownload);
	var adownload = Components.classes["@mozilla.org/download;1"].createInstance(Components.interfaces.nsIDownload);
	adownload = db_gDownloadManager.getDownload(elemid);
	//pdialog.cancelDownloadOnClose = false;  Not needed because the dialog is not connected to the download, the dialog is just listening
   
	dl.init(adownload.source, adownload.target, null, adownload.MIMEInfo, adownload.startTime, null);
  
	var dialistener = pdialog.QueryInterface(Components.interfaces.nsIWebProgressListener);
	adownload.listener = dialistener; 
	//internalDownload->SetDialog(pdialog); Can I do this in java? Need to access the nsdownload not the nsIDownload.
	//This would connect the download to the dialog, ie cancel download button would work on the dialog.
	pdialog.open(window);
	window.setTimeout(changecloselabel, 100);
	
	//old version 0.5
	//db_gDownloadManager.openProgressDialogFor(elemid, window);
	//document.getElementById(elemid).hidden = true;
	//access widow-mediator - dialog - CloseDownloadOnClose = false
	//old
}*/

/*function changecloselabel(){ // Depreciated - used with expand to window
	var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
	ww.activeWindow.document.getElementById("cancel").label = "Close"
	ww.activeWindow.document.getElementById("pauseResume").hidden = "true"
}*/

// In the future use a separate window and keep track of where it should be with boxObject stuff
//var statbar = document.getElementById("status-bar");
//aConsoleService.logStringMessage(statbar.boxObject.height + " - " + statbar.boxObject.width + " - " + statbar.boxObject.x + " - " + statbar.boxObject.y);
